export default class {
  execute(properties, params, component) {
    Utils.http.startIndicator(component);

    const stripe = Stripe(properties.publicKey);

    if (properties.setupOnly) {
      stripe.confirmCardSetup(properties.clientSecret).then(function(result) {
        Utils.http.stopIndicator(component);

        if (result.error) {
          GLib.action.execute(properties.onFailure, component);
        } else {
          GLib.action.execute(properties.onSuccess, component);
        }
      });
    } else {
      stripe.handleCardAction(properties.clientSecret).then(function(result) {
        Utils.http.stopIndicator(component);

        if (result.error) {
          GLib.action.execute(properties.onFailure, component);
        } else {
          GLib.action.execute(properties.onSuccess, component);
        }
      });
    }
  }
}
