import Driver from "driver.js";
import "driver.js/dist/driver.min.css";

let driver = null;

export default class {
  execute(spec, component) {
    driver = new Driver(spec.options || {});
    let steps = spec.steps;
    steps
      .filter(value => value.customBehavior)
      .forEach(step => {
        const element = document.querySelector(step.element);
        component.driverCustomBehavior[step.customBehavior](element, driver);
      });
    driver.defineSteps(steps);
    driver.start(spec.startFrom || 0);
  }

  static stopTour() {
    if (driver) {
      driver.reset();
      driver = null;
    }
  }
}
