// https://stackoverflow.com/questions/7616461/generate-a-hash-from-string-in-javascript
String.prototype.hashCode = function() {
  var hash = 0,
    i,
    chr;
  if (this.length === 0) return hash;
  for (i = 0; i < this.length; i++) {
    chr = this.charCodeAt(i);
    hash = (hash << 5) - hash + chr;
    hash |= 0; // Convert to 32bit integer
  }
  return hash;
};

String.prototype.contains = function(substr) {
  return this.indexOf(substr) > -1;
};

String.prototype.presence = function() {
  return this.length > 0 ? this.toString() : null;
};

String.prototype.truncate = function(n) {
  return this.length > n ? this.slice(0, n - 1) + "..." : this.toString();
};

// See https://stackoverflow.com/questions/3586775/what-is-the-correct-way-to-check-for-string-equality-in-javascript
String.prototype.equals = function(str) {
  // Perform comparison on the primitive string values
  return this.valueOf() == str.valueOf();
};

String.prototype.compare = function(str) {
  const str1 = this.valueOf();
  const str2 = str.valueOf();
  if (str1 < str2) {
    return -1;
  }
  if (str1 > str2) {
    return 1;
  }
  return 0;
};

String.prototype.squish = function() {
  return this.replace(/\s+/g, " ").trim();
};
