export default {
  install: (Vue, options) => {
    Vue.mixin({
      mounted: function() {
        let spec = this.spec;
        if (spec && spec.id && this.$registryEnabled()) {
          GLib.component.register(spec.id, this);
        }
      },
      destroyed: function() {
        let spec = this.spec;
        if (spec && spec.id && this.$registryEnabled()) {
          GLib.component.deregister(spec.id);
        }
      },
      methods: {
        $registryEnabled() {
          // Common classes such as `_select` need to return false so that it doesn't override its parent (e.g. `select`).
          return true;
        }
      }
    });
  }
};
