import Vue from "vue";

export default class {
  static get _registry() {
    return window.vueApp.registeredComponents;
  }

  static findById(id) {
    return this._registry[id];
    // const component = this._registry[id];
    // if (component) {
    //   return component;
    // }
    // console.error("Component not found: " + id);
  }

  // static clearRegistry() {
  //   window.vueApp.registeredComponents = {};
  // }

  static register(id, component) {
    if (this._registry[id]) {
      console.warn(
        "Duplicate component ID:",
        id,
        "Existing:",
        this.vueName(this._registry[id]),
        "New:",
        this.vueName(component)
      );
    }

    this._registry[id] = component;
  }

  static deregister(id) {
    delete this._registry[id];
  }

  static vueName(component) {
    return component.$options._componentTag;
  }

  static async preserveScroll(promise) {
    const pageBody = this.$pageBody;
    const originalTop = pageBody.scrollTop;
    const originalLeft = pageBody.scrollLeft;

    await promise;

    Vue.nextTick(() => {
      pageBody.scrollTop = originalTop;
      pageBody.scrollLeft = originalLeft;
    });
  }

  static get $pageBody() {
    return document.getElementById("page_body");
  }
}
